package dev.shadowsoffire.apotheosis.village.wanderer;

import com.mojang.datafixers.kinds.Applicative;
import dev.shadowsoffire.placebo.codec.PlaceboCodecs;
import dev.shadowsoffire.placebo.json.ItemAdapter;
import com.mojang.datafixers.kinds.App;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import net.minecraft.world.item.ItemStack;
import com.mojang.serialization.Codec;
import net.minecraftforge.common.BasicItemListing;

public class WandererTrade extends BasicItemListing implements JsonTrade
{
    public static Codec<WandererTrade> CODEC;
    protected final boolean rare;
    
    public WandererTrade(final ItemStack price, final ItemStack price2, final ItemStack forSale, final int maxTrades, final int xp, final float priceMult, final boolean rare) {
        super(price, price2, forSale, maxTrades, xp, priceMult);
        this.rare = rare;
    }
    
    public boolean isRare() {
        return this.rare;
    }
    
    public Codec<? extends JsonTrade> getCodec() {
        return WandererTrade.CODEC;
    }
    
    static {
        WandererTrade.CODEC = (Codec<WandererTrade>)RecordCodecBuilder.create(inst -> inst.group((App)ItemAdapter.CODEC.fieldOf("input_1").forGetter(trade -> trade.price), (App)PlaceboCodecs.nullableField(ItemAdapter.CODEC, "input_2", (Object)ItemStack.f_41583_).forGetter(trade -> trade.price2), (App)ItemAdapter.CODEC.fieldOf("output").forGetter(trade -> trade.forSale), (App)PlaceboCodecs.nullableField((Codec)Codec.INT, "max_trades", (Object)1).forGetter(trade -> trade.maxTrades), (App)PlaceboCodecs.nullableField((Codec)Codec.INT, "xp", (Object)0).forGetter(trade -> trade.xp), (App)PlaceboCodecs.nullableField((Codec)Codec.FLOAT, "price_mult", (Object)1.0f).forGetter(trade -> trade.priceMult), (App)PlaceboCodecs.nullableField((Codec)Codec.BOOL, "rare", (Object)false).forGetter(trade -> trade.rare)).apply((Applicative)inst, WandererTrade::new));
    }
}
